## xdg-utils-cxx 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(XdgUtils)
set(PROJECT_VERSION 0.1.1)
set(PROJECT_DESCRIPTION "Freedesktop standards C++ implementation")
set(PROJECT_HOMEPAGE_URL https://github.com/azubieta/xdg-utils-cxx)

## Configuration options
option(XDG_UTILS_SHARED "Build shared libs instead of static" OFF)
option(XDG_UTILS_TESTS "Build tests" OFF)
option(XDG_UTILS_CODE_COVERAGE "Build Code Coverage report" OFF)

## Global variables

# Request C++-11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Set GNU Install Dirs variables
include(GNUInstallDirs)

# Prepare code coverage
include(cmake/code_coverge_config.cmake)

# Sources
add_subdirectory(src)

# Tests
enable_testing()
add_subdirectory(tests)

=== src/CMakeLists.txt ===
# Build variables
set(PROJECT_INCLUDEDIR ${PROJECT_SOURCE_DIR}/include)

# Install variables
set(PROJECT_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR}/XdgUtils)
set(PROJECT_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR}/XdgUtils)
set(PROJECT_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

set(PROJECT_COMPONENT ${PROJECT_NAME})
set(PROJECT_COMPONENT_DEVEL ${PROJECT_NAME})

# Modules
include(${PROJECT_SOURCE_DIR}/cmake/module_utils.cmake)

add_subdirectory(DesktopEntry)
add_subdirectory(BaseDir)

include(${PROJECT_SOURCE_DIR}/cmake/generate_cmake_package.cmake)

=== tests/CMakeLists.txt ===
if(XDG_UTILS_TESTS)
    include(fetch_and_build_gtest.cmake)
    include(utils.cmake)

    add_subdirectory(DesktopEntry)
    add_subdirectory(BaseDir)
        
    include(setup_coverage_target.cmake)
endif()

=== src/BaseDir/CMakeLists.txt ===
add_xdgutils_module(BaseDir BaseDir.cpp)
install_xdgutils_module(BaseDir)

=== src/DesktopEntry/CMakeLists.txt ===
set(DesktopEntry_SOURCES_DIR ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(AST)
add_subdirectory(Reader)

set(
    srcs

    DesktopEntry.cpp
    DesktopEntryKeyPath.cpp
    DesktopEntryKeyValue.cpp
    DesktopEntryExecValue.cpp
    DesktopEntryStringsValue.cpp

    "$<TARGET_OBJECTS:XdgUtilsDesktopEntryAST>"
    "$<TARGET_OBJECTS:XdgUtilsDesktopEntryReader>"
)

add_xdgutils_module(DesktopEntry "${srcs}")
install_xdgutils_module(DesktopEntry)

=== tests/BaseDir/CMakeLists.txt ===
add_gtest(TestXdgUtilsBaseDir TestBaseDir.cpp)

target_link_libraries(TestXdgUtilsBaseDir XdgUtils::BaseDir)

=== tests/DesktopEntry/CMakeLists.txt ===
add_subdirectory(AST)
add_subdirectory(Reader)

add_gtest(
    TestXdgUtilsDesktopEntry

    TestDesktopEntry.cpp
    TestDesktopEntryKeyPath.cpp
    TestDesktopEntryValue.cpp
    TestDesktopEntryExecValue.cpp
    TestDesktopEntryStringsValue.cpp
)

target_link_libraries(TestXdgUtilsDesktopEntry XdgUtils::DesktopEntry)

=== src/DesktopEntry/AST/CMakeLists.txt ===
set(srcs AST.cpp Group.cpp Entry.cpp Comment.cpp Node.cpp)

add_library(XdgUtilsDesktopEntryAST OBJECT ${srcs})
target_include_directories(XdgUtilsDesktopEntryAST PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

if(XDG_UTILS_SHARED)
    set_property(TARGET XdgUtilsDesktopEntryAST PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

=== src/DesktopEntry/Reader/CMakeLists.txt ===
set(srcs Lexer.cpp Token.cpp Tokenizer.cpp Reader.cpp)

add_library(XdgUtilsDesktopEntryReader OBJECT ${srcs})

target_include_directories(XdgUtilsDesktopEntryReader
    PUBLIC $<BUILD_INTERFACE:${DesktopEntry_SOURCES_DIR}>
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    )
if(XDG_UTILS_SHARED)
    set_property(TARGET XdgUtilsDesktopEntryReader PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

=== tests/DesktopEntry/AST/CMakeLists.txt ===
set(
    srcs

    TestAST.cpp
    TestEntry.cpp
    TestComment.cpp
    TestGroup.cpp
    "$<TARGET_OBJECTS:XdgUtilsDesktopEntryAST>"
)

add_gtest(TestXdgUtilsDesktopAST "${srcs}")
target_include_directories(TestXdgUtilsDesktopAST PRIVATE ${PROJECT_SOURCE_DIR}/src/DesktopEntry/AST)

=== tests/DesktopEntry/Reader/CMakeLists.txt ===
set(
    srcs

    TestDesktopEntryReaderLexer.cpp
    TestDesktopEntryReaderTokenizer.cpp
    TestDesktopEntryReader.cpp
    "$<TARGET_OBJECTS:XdgUtilsDesktopEntryAST>"
    "$<TARGET_OBJECTS:XdgUtilsDesktopEntryReader>"
)

add_gtest(TestXdgUtilsDesktopEntryReader "${srcs}")
target_include_directories(TestXdgUtilsDesktopEntryReader PRIVATE ${PROJECT_SOURCE_DIR}/src/DesktopEntry)

=== debian/changelog ===
xdg-utils-cxx (1.0.1-3.1build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:53:48 +0200

xdg-utils-cxx (1.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/*.symbols: Dropped, use shlibs file instead to avoid
    C++ symbol mess. Using symbols file is also unnecessary since
    the version string is embedded in SONAME. (Closes: #1004109)
  * debian/*.shlibs: Added, use required version (>= 1.0.1).
  * debian/control: Fix typo.
  * debian/control: Let xdg-utils-cxx depends on xdg-utils-cxx-dev
    for proper package transition.
  * debian/control: Drop ${shlibs:Depends} substvar for dev package.

 -- Boyuan Yang <byang@debian.org>  Sat, 30 Jul 2022 21:06:24 -0400

xdg-utils-cxx (1.0.1-3) unstable; urgency=medium

  * Add patches provided by Assassin to fix issues with targets and
    upstream uses of this library.
    - Fix the SO version.
    - Fix the install path to be in a searched lib path.
    - Clean up patches and make them DEP 3 compliant.
  * Convert package to libraries and dev packages for symbols
    handling.
    - Break package into libraries and dev packages with
      virtual package for old package.
    - Use pkg-kde-tools for easier symbols handling.
    - Add new symbols files for libraries.
  * Remove unused dependency pkg-config.
  * Fix lintian errors.
    - Rename packages to match SO version.
    - Fix spelling error.
    - Fix hardening export in rules.
  * Remove dh_missing override as --fail-missing is now default.
  * Fix pkgkde addons call, use out of source build directory.
  * Don't build tests as these do not test the installed binaries.
  * Remove excess build dir overrides as now we use global override.
  * Release to unstable.

 -- Scarlett Moore <sgmoore@kde.org>  Thu, 11 Mar 2021 12:24:59 -0700

xdg-utils-cxx (1.0.1-2) unstable; urgency=medium

  * Update copyright with missing entry.
    - Refresh formatting.
  * Update standards version to 4.5.1; no changes needed.
  * Add upstream patch to fix typo. (lintain)
  * Release to unstable.

 -- Scarlett Moore <sgmoore@kde.org>  Tue, 19 Jan 2021 10:08:38 -0700

xdg-utils-cxx (1.0.1-1) unstable; urgency=medium

  [ Scarlett Moore ]
  * Initial release (Closes: #934253)

 -- Scarlett Moore <sgmoore@kde.org>  Wed, 13 Jan 2021 14:35:26 -0700

=== debian/control ===
Source: xdg-utils-cxx
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Scarlett Moore <sgmoore@kde.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 pkg-kde-tools,
Standards-Version: 4.6.1
Homepage: https://github.com/azubieta/xdg-utils-cxx
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/xdg-utils-cxx
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/xdg-utils-cxx
Rules-Requires-Root: no

Package: xdg-utils-cxx-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxdgutilsbasedir1.0.1 (= ${binary:Version}),
 libxdgutilsdesktopentry1.0.1 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 xdg-utils-cxx (<< 1.0.1-3~),
Replaces:
 xdg-utils-cxx (<< 1.0.1-3~),
Description: Implementation of the Free Desktop Standards in C++
 This project was started to fulfill the need of a reliable
 implementations of such standards in the AppImage project.
 It is totally standalone and only depends on
 the standard c++ library (stdlib).
 .
 It has been split in different modules according to the
 Free Desktop Standards, the current implemented ones are:
    - Desktop Entry 1.2 (mostly complete)
    - Base Dir 0.7 (draft)
 .
 These are the development files for xdg-utils-cxx Desktop Entry
 and BaseDir components.

Package: libxdgutilsdesktopentry1.0.1
Architecture: any
Multi-Arch: same
Breaks:
 xdg-utils-cxx (<< 1.0.1-3~),
Replaces:
 xdg-utils-cxx (<< 1.0.1-3~),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Implementation Desktop Entry in Free Desktop Standards for C++
 This project was started to fulfill the need of a reliable
 implementations of such standards in the AppImage project.
 It is totally standalone and only depends on
 the standard c++ library (stdlib).
 .
 It has been split in different modules according to the
 Free Desktop Standards, the current implemented ones are:
    - Desktop Entry 1.2 (mostly complete)
    - Base Dir 0.7 (draft)
 .
 This is the library files for Desktop Entry.

Package: libxdgutilsbasedir1.0.1
Architecture: any
Multi-Arch: same
Breaks:
 xdg-utils-cxx (<< 1.0.1-3~),
Replaces:
 xdg-utils-cxx (<< 1.0.1-3~),
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Implementation BaseDir in Free Desktop Standards for C++
 This project was started to fulfill the need of a reliable
 implementations of such standards in the AppImage project.
 It is totally standalone and only depends on
 the standard c++ library (stdlib).
 .
 It has been split in different modules according to the
 Free Desktop Standards, the current implemented ones are:
    - Desktop Entry 1.2 (mostly complete)
    - Base Dir 0.7 (draft)
 .
 This is the library files for BaseDir.

Package: xdg-utils-cxx
Architecture: any
Depends:
 xdg-utils-cxx-dev (= ${binary:Version}),
 ${misc:Depends},
Section: oldlibs
Description: Core libraries for xdg-utils-cxx - transitional
 This is a dummy transitional package which can be removed.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with pkgkde-symbolshelper -Bbuild

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DXDG_UTILS_SHARED=ON -DXDG_UTILS_TESTS=OFF

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%xdg-utils-cxx-$1.tar.gz%" \
   https://github.com/azubieta/xdg-utils-cxx/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
